'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var priorityQueue = require('@algorithm.ts/priority-queue');

function dijkstra(N, source, G, ZERO, INF) {
    const dist = new Array(N).fill(INF);
    const Q = priorityQueue.createPriorityQueue((x, y) => y.cost - x.cost);
    dist[source] = ZERO;
    Q.enqueue({ pos: source, cost: ZERO });
    while (Q.size() > 0) {
        const { pos, cost } = Q.dequeue();
        if (dist[pos] < cost)
            continue;
        for (const e of G[pos]) {
            const candidate = dist[pos] + e.cost;
            if (dist[e.to] > candidate) {
                dist[e.to] = candidate;
                Q.enqueue({ pos: e.to, cost: dist[e.to] });
            }
        }
    }
    return dist;
}

exports["default"] = dijkstra;
exports.dijkstra = dijkstra;
